#!/usr/bin/bash --noprofile 
# Why bash: because the source code is free and portable
# http://www.sunfreeware.com
#
set -x
VHDL_TEST="inlet_test"
VHDL_LIB_DEFAULT="C"

if [   -e pipe1         ]; then rm -f pipe1; fi
if [   -e pipe2         ]; then rm -f pipe2; fi

if [   -z "${VHDL_LIB}" ]; then VHDL_LIB="${VHDL_LIB_DEFAULT}"; fi
if [ ! -d "${VHDL_LIB}" ]; then mkdir ${VHDL_LIB}; fi
if [ ! -d "WORK" ];        then mkdir WORK; fi

cd ../source_c
gcc inlet.c -o inlet
cd ../test

vhdlan -NOEVENT -work ${VHDL_LIB} ../source/strings_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work ${VHDL_LIB} ../source/ctype_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work ${VHDL_LIB} ../source/stdlib_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work ${VHDL_LIB} ../source/regexp_h.vhd
  if [ $? != 0 ]; then exit $?; fi

cd ../source_make
./stdio_h.sh
cd ../test

if [ -f ../source_make/stdio_h.vhd]; then
  rm -f ../source/stdio_h.vhd
  cp ../source_make/stdio_h.vhd ../source/stdio_h.vhd
fi


vhdlan -NOEVENT -work ${VHDL_LIB} ../source/stdio_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT                   ${VHDL_TEST}.vhd
  if [ $? != 0 ]; then exit $?; fi


#Is pipe1 a fifo pipe?
if [ ! -p "./pipe1" ]; then mkfifo pipe1; fi
if [ ! -p "./pipe2" ]; then mkfifo pipe2; fi

../source_c/inlet ./pipe1 ./pipe2 &

cat inlet_test_file.txt > pipe1 &

echo -ne "run\nquit\n" >vrun_temp_cmd.txt

vhdlsim -i vrun_temp_cmd.txt -o ${VHDL_TEST}.txt ${VHDL_TEST}_cfg
#vhdlsim -i vrun_temp_cmd.txt ${VHDL_TEST}_cfg

diff ${VHDL_TEST}.txt ${VHDL_TEST}_vss.txt

#vi ${VHDL_TEST}.txt

#kill the pipe
### solaris specific command "ps -af"
ps -af
kill -9 `ps -af | grep 'inlet [^p]*pipe1 [^p]*pipe2' | awk '{ print $2 }'`
rm -fr C WORK vrun_temp_cmd.txt
rm -f pipe1 pipe2
rm -f ../source_c/inlet

