#!/usr/bin/bash --noprofile 
# Why bash: because the source code is free and portable
# http://www.sunfreeware.com
#
set -x
VHDL_TEST="stdio_h_test"
VHDL_LIB_DEFAULT="C"

if [   -z "${VHDL_LIB}" ]; then VHDL_LIB="${VHDL_LIB_DEFAULT}"; fi
if [ ! -d "${VHDL_LIB}" ]; then mkdir ${VHDL_LIB}; fi
if [ ! -d WORK ];          then mkdir WORK; fi

vhdlan -NOEVENT -work ${VHDL_LIB} ../source/strings_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work ${VHDL_LIB} ../source/ctype_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work ${VHDL_LIB} ../source/stdlib_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work ${VHDL_LIB} ../source/regexp_h.vhd
  if [ $? != 0 ]; then exit $?; fi

cd ../source_make
./stdio_h.sh
cd ../test

if [ -f ../source_make/stdio_h.vhd]; then
  rm -f ../source/stdio_h.vhd
  cp ../source_make/stdio_h.vhd ../source/stdio_h.vhd
fi

vhdlan -NOEVENT -work ${VHDL_LIB} ../source/stdio_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT                   ${VHDL_TEST}.vhd
  if [ $? != 0 ]; then exit $?; fi

echo -ne "run\nquit\n" >vrun_temp_cmd.txt

vhdlsim -i vrun_temp_cmd.txt -o ${VHDL_TEST}.txt ${VHDL_TEST}_cfg

rm -fr C WORK vrun_temp_cmd.txt 
rm -f xxx_fout1.txt xxx_fout2.txt xxx_out.txt

diff ${VHDL_TEST}.txt ${VHDL_TEST}_vss.txt

#vi ${VHDL_TEST}.txt

