/*
-- File:    inlet.c
-- Version: 1.0	 (March 13, 2002)
-- Source:  http://bear.ces.cwru.edu/vhdl
-- Date:    March 13, 2002 (Copyright)
-- Author:  Francis G. Wolff   Email: fxw12@po.cwru.edu
-- Author:  Michael J. Knieser Email: mjknieser@knieser.com
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 1, or (at your option)
-- any later version: http://www.gnu.org/licenses/gpl.html
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <strings.h>

int main(int argc, char *argv[]) {
  int fin, fout; char buf[1024]; int len;
  /* fprintf(stderr, "inlet begin\n"); for debug only */
    
  if (argc == 3) {
    if (!strcmp(argv[2], "-")) { fout=1; }
    else {
      fout = open(argv[2], O_WRONLY, 0666);
      if (fout<0) {
        fprintf(stderr, "inlet: open(%s, O_WRONLY, 0666) error\n", argv[2]); exit(1);
    } }

    for(;;) {
      fin = open(argv[1], O_RDONLY, 0);
      if (fin<0) {
        fprintf(stderr, "inlet: open(%s, O_RDONLY, 0) error\n", argv[1]); exit(1);
      }

      while ((len = read(fin, buf, sizeof(buf))) > 0) {
        if (write(fout, buf, len) != len) {
            perror("inlet: write");
            return 1;
        }
      }

      if (len < 0) { perror("inlet: read"); return 1; }
      close(fin);
  } }
  else {
    fprintf(stderr, "inlet <pipe in> <pipe out>\n  If filename is dash then stdout\n");
  }
  return 0;
}

