#!/usr/bin/bash --noprofile 
# Why bash: because the source code is free and portable
# http://www.sunfreeware.com
#
set -x
VHDL_TEST=inlet_testlib
VHDL_LIB_DEFAULT="./C"

if [   -z "${VHDL_LIB}" ]; then VHDL_LIB="${VHDL_LIB_DEFAULT}"; fi
if [ ! -d "${VHDL_LIB}" ]; then mkdir ${VHDL_LIB}; fi

gcc inlet.c -o inlet

vhdlan -NOEVENT -work C strings_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work C ctype_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work C stdlib_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT -work C regexp_h.vhd
  if [ $? != 0 ]; then exit $?; fi

./stdio_h.sh

vhdlan -NOEVENT -work C stdio_h.vhd
  if [ $? != 0 ]; then exit $?; fi
vhdlan -NOEVENT ${VHDL_TEST}.vhd
  if [ $? != 0 ]; then exit $?; fi


#Is pipe1 a fifo pipe?
if [ ! -p "./pipe1" ]; then mkfifo pipe1; fi
if [ ! -p "./pipe2" ]; then mkfifo pipe2; fi

./inlet ./pipe1 ./pipe2 &
cat inlet_test_file.txt > pipe1 &

echo -ne "run\nquit\n" >vrun_temp_cmd.txt

vhdlsim -i vrun_temp_cmd.txt -o ${VHDL_TEST}.txt ${VHDL_TEST}_cfg
#vhdlsim -i vrun_temp_cmd.txt ${VHDL_TEST}_cfg

vi ${VHDL_TEST}.txt

#kill the pipe
kill -9 `ps -a | grep inlet | awk '{ print $1 }'`

